package com.totopia.server.modules.game.entity;

import com.totopia.server.commons.data.entity.DateAuditEntity;
import com.vladmihalcea.hibernate.type.json.JsonStringType;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;
import org.hibernate.annotations.TypeDefs;

import javax.persistence.*;
import java.util.Map;

@Entity
@Table(name = "sports_event_result")
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@Builder
@TypeDefs({
    @TypeDef(name = "json", typeClass = JsonStringType.class)
})
public class SportsEventResultEntity extends DateAuditEntity {

  @Id
  @GeneratedValue(generator = "sports_event_result_generator")
  @SequenceGenerator(name = "sports_event_result_generator", sequenceName = "sports_event_result_sequence", initialValue = 1)
  private Long id;

  @Column(name = "sports_event_id", unique = true)
  private Long sportsEvent;

  @Column(name = "status")
  private Short status;

  @Column(name = "home_full_time_score")
  private Short homeFullTimeScore;

  @Column(name = "home_final_score")
  private Short homeFinalScore;

  @Column(name = "away_full_time_score")
  private Short awayFullTimeScore;

  @Column(name = "away_final_score")
  private Short awayFinalScore;

  @Type(type = "json")
  @Column(name = "score_info", columnDefinition = "json")
  private Map<String, Object> scoreInfo;

}
