package com.totopia.server.modules.info.service;

import com.totopia.server.modules.info.entity.FreeBoardEntity;
import com.totopia.server.modules.info.repository.FreeBoardRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service
public class FreeBoardService {

  @Autowired
  private FreeBoardRepository freeBoardRepository;

  public void save(FreeBoardEntity freeBoardEntity) throws Exception {
    freeBoardEntity.setCreatedBy(freeBoardEntity.getOwner());
    this.freeBoardRepository.save(freeBoardEntity);
  }

  public Page<FreeBoardEntity> getAllByPageable(Pageable pageable) {
    return this.freeBoardRepository.findAll(pageable);
  }

  public FreeBoardEntity modify(FreeBoardEntity freeBoardEntity) {
    freeBoardEntity.setUpdatedBy(1L);
    freeBoardEntity.setUpdatedAt(new Date());
    return this.freeBoardRepository.save(freeBoardEntity);
  }

  public Long removeById(Long boardId) {
    this.freeBoardRepository.deleteById(boardId);
    return boardId;
  }

  public FreeBoardEntity getBoardById(Long boardId) {
    return this.freeBoardRepository.findById(boardId).orElseThrow(null);
  }
}
